/*

   Copyright (c) 2000-2007 FrontBase, Inc.
   Portions Copyright (c) 1994-2006 Tim Bunce

   You may distribute under the terms of either the GNU General Public
   License or the Artistic License, as specified in the Perl README file.
   
   Non-standard calls go in here.

*/


#include "FB.h"
#ifdef WIN32
#define strncasecmp strnicmp	//cr
#endif

DBISTATE_DECLARE;

MODULE = DBD::FB	PACKAGE = DBD::FB

#define dbd_st_rows dbd_st_rows
#define dbd_discon_all dbd_discon_all

INCLUDE: FB.xsi
	
# ------------------------------------------------------------
# database level interface
# ------------------------------------------------------------
MODULE = DBD::FB	PACKAGE = DBD::FB::db

int
fb_ping(dbh)
    SV *	dbh
    CODE:
    RETVAL = dbd_db_ping(dbh);
    if (RETVAL == 0) {
        XST_mUNDEF(0);
    }
    else {
        XST_mIV(0, RETVAL);
    }

SV *
digest_password(password, username)
	char *	password
	char *	username
	CODE:
		RETVAL = fb_db_digestPassword(password, username);
	OUTPUT:
		RETVAL
	
# ------------------------------------------------------------
# statement interface
# ------------------------------------------------------------
MODULE = DBD::FB	PACKAGE = DBD::FB::st

void
fb_prepare(sth, statement, attribs=Nullsv)
    SV *	sth
    char *	statement
    SV *	attribs
    CODE:
    {
    D_imp_sth(sth);
    D_imp_dbh_from_sth;
    DBD_ATTRIBS_CHECK("fb_prepare", sth, attribs);
    if (!strncasecmp(statement, "begin",    5) ||
        !strncasecmp(statement, "end",      4) ||
        !strncasecmp(statement, "commit",   6) ||
        !strncasecmp(statement, "abort",    5) ||
        !strncasecmp(statement, "rollback", 8) ) {
        warn("please use DBI functions for transaction handling");
        ST(0) = &sv_no;
    } else {
        ST(0) = dbd_st_prepare(sth, imp_sth, statement, attribs) ? &sv_yes : &sv_no;
    }
    }

# end of FB.xs
