
# $Id: Makefile.PL,v 1.1 2002/05/03 18:56:31 jness Exp $

use ExtUtils::MakeMaker;
use Config qw(%Config);
use strict;
use DBI 1.10;
use DBI::DBD;

print "\nConfiguring FB\n";
print "Remember to actually read the README file !\n";
die "\nYou didn't read the README file !\n" unless ($] >= 5.005);

my $os = $^O;

if (! $ENV{FRONTBASE_HOME}) {
    print "Environment variable FRONTBASE_HOME not defined. Searching for Frontbase...\n";
	if ($os eq 'MSWin32')
	{ 
		foreach(qw(\usr\FrontBase)) 
		{
			if (-d "$_/lib") 
			{
				$ENV{FRONTBASE_HOME} = $_;
				last;
			}
		}
	}
	else
	{
		foreach(qw(/Library/Frontbase /Local/Library/FrontBase /usr/FrontBase /opt/FrontBase /usr/local/FrontBase)) 
		{
			if (-d "$_/lib") 
			{
				$ENV{FRONTBASE_HOME} = $_;
				last;
			}
		}
	}
}

if (defined($ENV{FRONTBASE_HOME}) && -d "$ENV{FRONTBASE_HOME}/lib") {
    print "Found Frontbase in $ENV{FRONTBASE_HOME}\n";
} else {
    die "Unable to find Frontbase\nplease set environment variable FRONTBASE_HOME\n";
}

print "Configuring for ",$os, "\n";

my $libFBCAccess = 'libFBCAccess.a';

if ($os eq 'MSWin32') {
	$libFBCAccess = 'FBCAccess.lib';
}

# cr1.36
my %opts = (
    NAME			=> 'DBD::FB',
    DISTNAME		=> 'DBD-FB',
    VERSION_FROM	=> 'FB.pm',
    INC				=> "-I$ENV{FRONTBASE_HOME}/include -I\$(INSTALLSITEARCH)/auto/DBI -I\$(INSTALLARCHLIB)/DBI -I\$(SITEARCH)/auto/DBI -I\$(ARCHLIB)/DBI",
	OBJECT			=> "FB\$(OBJ_EXT) dbdimp\$(OBJ_EXT) $ENV{FRONTBASE_HOME}/lib/$libFBCAccess",
	dist			=> { COMPRESS => 'gzip -9f', SUFFIX => 'gz', POSTOP => 'mv $(DISTNAME)-$(VERSION).tar.gz ../' },
	realclean		=> { FILES => '*.xsi' }
);
 
if ($os eq 'MSWin32') {
 my $ccflags = $Config{ccflags}." -DWinNT";
 my $ldloadlibs = $Config{libs};
 $opts{CCFLAGS} = $ccflags;
 $opts{LIBS} = $ldloadlibs.' ws2_32.lib';
}

my $osvers = $Config{osvers};
if ($os eq 'hpux') {
    if ($osvers < 10) {
        print "Warning: Forced to build static not dynamic on $os $osvers.\a\n";
        $opts{LINKTYPE} = 'static';
    }
}

if ($Config{dlsrc} =~ /dl_none/) {
    $opts{LINKTYPE} = 'static';
}

WriteMakefile(%opts);

# cr1.36 start
package MY;
sub postamble { return main::dbd_postamble(@_); }
# cr1.36 end
exit(0);

# end of Makefile.PL
