#!perl -w

# Cleanup by removing the test tables

use Test::More tests => 3;
use DBI;
use Sys::Hostname;
use strict;
$|=1;

# defaults for connection

my $dsn = $ENV{DBI_DSN};
my $user = "_SYSTEM";
my $passwd = "";
my $hostname = hostname;
my $dbname = "test";
my $dbpasswd = "";

# DSN_xxx values override defaults

if($dsn && $dsn =~ s/^(dbi):(\w*?)(?:\((.*?)\))?://i && lc($2) eq 'fb') {
	$dbpasswd = $1 if($3 && $3 =~ /\bfb_dbpasswd\b\s*=>\s*(\w+)/);
	$dbname = $1 if($dsn =~ /\bdbname\b\s*=\s*(\w+)/);
	$hostname = $1 if($dsn =~ /\bhost\b\s*=\s*([\.A-Za-z0-9_]+)/);
}
$user = $ENV{DBI_USER} if ($ENV{DBI_USER});
$passwd = $ENV{DBI_PASS} if ($ENV{DBI_PASS});

# FB_xxx values override DSN_xxx values

$hostname = $ENV{FB_HOST} if ($ENV{FB_HOST});
$dbname = $ENV{FB_DBNAME} if ($ENV{FB_DBNAME});
$dbpasswd = $ENV{FB_DBPASSWD} if ($ENV{FB_DBPASSWD});
$user = $ENV{FB_USER} if ($ENV{FB_USER});
$passwd = $ENV{FB_PASSWD} if ($ENV{FB_PASSWD});

my $dbh = DBI->connect("dbi:FB:dbname=$dbname;host=$hostname", $user, $passwd,
							{fb_dbpasswd => $dbpasswd, RaiseError => 1, PrintError => 0});

ok( defined $dbh, 'Connect to database for cleanup');

$dbh->do("DROP TABLE dbd_fb_test CASCADE");

my @result = $dbh->tables;
my $name;
for(@result) {
	if($_ eq 'dbd_fb_test') {
		$name = $_;
		last;
	}
}
	
isnt($name, 'dbd_fb_test', 'Table "dbd_fb_test" was dropped');

$dbh->do("DROP TABLE dbd_fb_datatypes CASCADE");

@result = $dbh->tables;

for(@result) {
	if($_ eq 'dbd_fb_datatypes') {
		$name = $_;
		last;
	}
}
	
isnt($name, 'dbd_fb_datatypes', 'Table "dbd_fb_datatypes" was dropped');

$dbh->disconnect();

